<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow title="Relatório de Vendas em Tempo Real"
			   xmlns:s="library://ns.adobe.com/flex/spark"  
			   xmlns:mx="library://ns.adobe.com/flex/mx" 
			   xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:component="br.com.desenv.nepalign.view.component.*"
			   xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*"
			   xmlns:renderer="br.com.desenv.framework.component.renderer.*"
			   xmlns:visual="br.com.desenv.framework.component.visual.*" close="{timer.stop(); UPCPopUpManager.instance.removePopUp(this)}"
			   creationComplete="titlewindow1_creationCompleteHandler(event)"
			   height="100%" minWidth="600">
	
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	<fx:Style>
		@namespace visual "br.com.desenv.framework.component.visual.*";
		@namespace s "library://ns.adobe.com/flex/spark";
		@namespace component "br.com.desenv.nepalign.view.component.*";
		@namespace autoComplete "br.com.desenv.framework.component.visual.autoComplete.*";
		@namespace mx "library://ns.adobe.com/flex/mx";
		
		.simpleDataGrid
		{
			use-rollover:false;
			borderStyle: none;
			alternatingItemColors: #FFFFF7, #FFFFF7;
			verticalGridLines: false;
			horizontalGridLines: false;
			paddingLeft: 0;
			paddingRight: 0;
			paddingTop: 0;
			paddingBottom: 0;	
		}
	</fx:Style>
	
	<fx:Script>
		<![CDATA[
			import mx.collections.ArrayCollection;
			import mx.collections.Sort;
			import mx.controls.Alert;
			import mx.core.FlexGlobals;
			import mx.events.CloseEvent;
			import mx.events.CollectionEvent;
			import mx.events.FlexEvent;
			import mx.events.IndexChangedEvent;
			import mx.managers.CursorManager;
			import mx.managers.PopUpManager;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.utils.ObjectUtil;
			
			import br.com.desenv.framework.component.formatter.Formatador;
			import br.com.desenv.nepalign.vo.SnapshotVenda;
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;  
			
			[Bindable]
			private var listaSnapshots:ArrayCollection;
			[Bindable]
			private var listaSnapshotsValores:ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaSnapshotsTotais:ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaSnapshotsLojas:Array;
			[Bindable]
			private var opRunning:Boolean = false;
			[Bindable]
			private var timer:Timer = new Timer(1000);
			
			private var segundosRestantes:int = 0x3C;
			
			protected function titlewindow1_creationCompleteHandler(event:FlexEvent):void
			{
				if(FlexGlobals.topLevelApplication.usuarioLogado.usuarioGlobal == "N")
				{
					Alert.show("Sem acesso à essa funcionalidade!", "Mensagem");
					UPCPopUpManager.instance.removePopUp(this);
					
					if(timer.running)
						timer.stop();
					
					mx.managers.CursorManager.removeBusyCursor();
					
					return;
				}
				
				timer.addEventListener(TimerEvent.TIMER, function(event:TimerEvent):void
				{
					if(FlexGlobals.topLevelApplication.loginForm != null)
					{
						timer.stop();
						dispatchEvent(new CloseEvent(CloseEvent.CLOSE));
						return;
					}
					
					segundosRestantes -= 0x01;
					
					if(segundosRestantes == 0x00)
					{
						timer.stop();
						
						labelProximaAtualizacao.text = "Atualizando valores...";
						
						segundosRestantes = 0x3C;
						AMFConnector.instance.prepararObjetoRemoto("snapshotVendaService", recuperarValoresResult, recuperarValoresFault).getOperation("recuperarValores").send();
					}
					else
						labelProximaAtualizacao.text = "00:" + (segundosRestantes < 0x0A ? ('0' + segundosRestantes) : segundosRestantes) + " para a próxima atualização";
				});
				
				content1.removeAllElements();
				
				AMFConnector.instance.prepararObjetoRemoto("snapshotVendaService", recuperarValoresResult, recuperarValoresFault).getOperation("recuperarValores").send();
			}
			
			protected function recuperarValoresResult(event:ResultEvent):void
			{
				listaSnapshotsLojas = [];
				
				for(var p:String in event.result)
				{
					listaSnapshotsLojas.push({label: parseInt(p), value: event.result[p]});
				}

				listaSnapshotsLojas.sort(function(a:*, b:*):int 
				{  
					var name1:int = a.label;
					var name2:int = b.label;
					
					if (name1 < name2) 
						return -0x01; 
					else if (name1 > name2) 
						return 0x01; 
					else 
						return 0x00; 
				});
				
				var contentNumber:int = 0x05;
				
				for(var index:int = 0x00; index < listaSnapshotsLojas.length; index++)
				{
					var hour:String = listaSnapshotsLojas[index].label;
					
					(navigator.getChildByName("content" + contentNumber) as VBox).label = (parseInt(hour) < 0x0A ? ('0' + hour) : hour) + ":00";
					
					contentNumber--;
				}

				callLater(function():void
				{					
					valoresErrorLabel.text = "";
					
					updateTabView(navigator.getChildByName("content1"));
					
					if(FlexGlobals.topLevelApplication.loginForm == null)
					{
						timer.start();
						
						var remoteObject:RemoteObject = AMFConnector.instance.prepararObjetoRemoto("snapshotVendaService", recuperarConexoesInativasResultHandler, function(event:FaultEvent):void {});
						remoteObject.showBusyCursor = false;
						remoteObject.getOperation("getConexoesInativas").send()
					}
				});
			}
			
			protected function recuperarValoresFault(event:FaultEvent):void
			{
				if(valoresErrorLabel.text != "")
				{
					if(!timer.running)
						timer.start();
					
					return;
				}
					
				function doubleDigitFormat(num:uint):String 
				{
					if(num < 0x0A)
						return ("0" + num);
					
					return num.toString();
				}
				
				var CurrentDateTime:Date = new Date();
				
				var DateString:String = doubleDigitFormat(CurrentDateTime.getDate()) + "/" + doubleDigitFormat(CurrentDateTime.getMonth()) + "/" +  CurrentDateTime.getFullYear().toString();
				var TimeString:String = doubleDigitFormat(CurrentDateTime.getHours()) + ":"+ doubleDigitFormat(CurrentDateTime.getMinutes());

				valoresErrorLabel.text = "Não foi possível recuperar os valores atuais! Ultima atualização às " + (DateString + " " + TimeString);
				timer.start();
			}
			
			protected function recuperarConexoesInativasResultHandler(event:ResultEvent):void
			{
				connectionErrorLabel.text = event.result as String;
			}
			
			protected function navigator_changeHandler(event:IndexChangedEvent):void
			{
				(navigator.getChildAt(event.oldIndex) as VBox).removeAllElements();
				updateTabView(navigator.getChildAt(event.newIndex));
			}
			
			protected function updateTabView(obj:DisplayObject):void
			{
				var label:String = (obj as VBox).label;
				
				if(label == "[S/I]")
					return; 
				
				var hour:String = label.split(":")[0x00];
				
				for(var h:String in listaSnapshotsLojas)
				{
					if(listaSnapshotsLojas[h].label == parseInt(hour))
					{
						listaSnapshots = listaSnapshotsLojas[h].value;
						listaSnapshotsValores.removeAll();
						listaSnapshotsTotais.removeAll();
						
						for(var index:int = 0x00; index < listaSnapshots.length; index++)
						{
							if(listaSnapshots.getItemAt(index).empresaFisica.id == 0x00)
								listaSnapshotsTotais.addItem(listaSnapshots.getItemAt(index));
							else
								listaSnapshotsValores.addItem(listaSnapshots.getItemAt(index));
						}
						
						listaSnapshotsValores.refresh();
						
						break;
					}
				}

				callLater(function():void
				{
					if(listaSnapshots == null)
						return;

					(obj as VBox).addElement(datagridListaSnapshots);
					(obj as VBox).addElement(datagridListaSnapshotsTotais);
				});
			}
			
			private function nomeEmpresaLabelFunction(item:Object, column:DataGridColumn):String
			{	
				if(item[column.dataField].id == 0x00)
					return item[column.dataField].razaoSocial;
				
				return item[column.dataField].nomeConcatenado;
			}
			
			private function valorLabelFunction(item:Object, column:DataGridColumn):String
			{	
				return Formatador.formatarDouble(Number(item[column.dataField]), 0x02);
			}
			
			protected function listaSnapshots_onColletionChange(event:CollectionEvent):void
			{

			}
		]]>
	</fx:Script>
	
	<mx:Grid paddingBottom="10" paddingLeft="10" paddingTop="10" paddingRight="10" width="100%">
		<mx:GridRow width="100%">
			<mx:GridItem width="60%">
				<mx:VBox width="100%">
					<s:Label id="connectionErrorLabel" text="" fontSize="10" fontWeight="bold" color="#FF0000"/>		
					<s:Label id="valoresErrorLabel" text="" fontSize="10" fontWeight="bold" color="#FF0000"/>
				</mx:VBox>
			</mx:GridItem>
			<mx:GridItem width="40%" horizontalAlign="right">
				<s:Label id="labelProximaAtualizacao" text="00:59 para a próxima atualização" fontSize="10" fontWeight="bold"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow paddingTop="10" width="100%">
			<mx:GridItem width="100%" colSpan="2">
				<mx:TabNavigator id="navigator" borderStyle="none" change="navigator_changeHandler(event)">
					<mx:VBox id="content1" label="[S/I]" verticalGap="0"> 
						<mx:DataGrid id="datagridListaSnapshots" width="100%" rowCount="11" verticalScrollPolicy="off" horizontalScrollPolicy="off" styleName="simpleDataGrid" dataProvider="{listaSnapshotsValores}">
							<mx:columns>
								<mx:DataGridColumn dataField="empresaFisica" sortable="false" labelFunction="nomeEmpresaLabelFunction" headerText="" width="250" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/>
								<mx:DataGridColumn dataField="valorVenda" labelFunction="valorLabelFunction" headerText="Total Venda" width="100" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/> <!-- labelFunction="DsvObjectUtil.formatDate" -->
								<mx:DataGridColumn dataField="valorCusto" labelFunction="valorLabelFunction" headerText="Total Custo" width="100" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/>
								<mx:DataGridColumn dataField="margem" labelFunction="valorLabelFunction" headerText="Margem" width="100" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/>
								<mx:DataGridColumn dataField="quantidade" headerText="Quantidade" width="100" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/>
							</mx:columns>
						</mx:DataGrid>
						<mx:DataGrid id="datagridListaSnapshotsTotais" showHeaders="false" width="100%" rowCount="3" verticalScrollPolicy="off" horizontalScrollPolicy="off" styleName="simpleDataGrid" dataProvider="{listaSnapshotsTotais}">
							<mx:columns>
								<mx:DataGridColumn dataField="empresaFisica" sortable="false" labelFunction="nomeEmpresaLabelFunction" headerText="" width="250" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/>
								<mx:DataGridColumn dataField="valorVenda" labelFunction="valorLabelFunction" headerText="Total Venda" width="100" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/> <!-- labelFunction="DsvObjectUtil.formatDate" -->
								<mx:DataGridColumn dataField="valorCusto" labelFunction="valorLabelFunction" headerText="Total Custo" width="100" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/>
								<mx:DataGridColumn dataField="margem" labelFunction="valorLabelFunction" headerText="Margem" width="100" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/>
								<mx:DataGridColumn dataField="quantidade" headerText="Quantidade" width="100" itemRenderer="br.com.desenv.framework.component.renderer.GridRowSnapshotVenda" direction="rtl"/>
							</mx:columns>
						</mx:DataGrid>
					</mx:VBox>
					<mx:VBox id="content2" label="[S/I]" verticalGap="0"/> 
					<mx:VBox id="content3" label="[S/I]" verticalGap="0"/> 
					<mx:VBox id="content4" label="[S/I]" verticalGap="0"/> 
					<mx:VBox id="content5" label="[S/I]" verticalGap="0"/> 
				</mx:TabNavigator>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>